<?php

namespace Pinpoint\Faq\Setup\Patch\Schema;

use Magento\Framework\DB\Ddl\Table;
use Magento\Framework\Setup\Patch\SchemaPatchInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;
use Pinpoint\Faq\Api\Data\FaqInterface;

class AddStoreId implements SchemaPatchInterface
{
    /**
     * @var ModuleDataSetupInterface
     */
    private $moduleDataSetup;

    /**
     * AddStoreId constructor.
     * @param ModuleDataSetupInterface $moduleDataSetup
     */
    public function __construct(
        ModuleDataSetupInterface $moduleDataSetup
    ) {
        $this->moduleDataSetup = $moduleDataSetup;
    }

    /**
     * @return array
     */
    public static function getDependencies()
    {
        return [];
    }

    /**
     * @return array
     */
    public function getAliases()
    {
        return [];
    }

    /**
     * {@inheritDoc}
     */
    public function apply()
    {
        $this->moduleDataSetup->startSetup();

        $this->moduleDataSetup->getConnection()->addColumn(
            $this->moduleDataSetup->getTable(FaqInterface::TABLE_NAME),
            FaqInterface::STORE_ID,
            [
                'type' => Table::TYPE_INTEGER,
                'nullable' => false,
                'comment' => 'Store ID',
                'length' => 11,
                'default' => '0'
            ]
        );

        $this->moduleDataSetup->endSetup();
    }

    /**
     * {@inheritDoc}
     */
    public function revert()
    {
        $this->moduleDataSetup->startSetup();

        $this->moduleDataSetup->getConnection()->dropColumn(
            $this->moduleDataSetup->getTable(FaqInterface::TABLE_NAME),
            FaqInterface::STORE_ID);

        $this->moduleDataSetup->endSetup();
    }
}